SystemOrganization addCategory: #'Atom-Elements'!
SystemOrganization addCategory: #'Atom-Content'!

!WriteStream methodsFor: '*atom' stamp: 'cwp 9/26/2007 21:38'!
br
	self nextPutAll: '&lt;br /&gt;'.
	self nextPut: Character lf! !

!WriteStream methodsFor: '*atom' stamp: 'cwp 7/27/2007 02:01'!
feedContent: aString
	aString do:
		[:char |
		char = $< 
			ifTrue: [self nextPutAll: '&lt;']
			ifFalse: [char = $& 
						ifTrue: [self nextPutAll: '&amp;']
						ifFalse: [char = Character cr
									ifTrue: [self br]
									ifFalse: [self nextPut: char]]]]! !

Object subclass: #AtomContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atom-Content'!

!AtomContent class methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2006 01:55'!
classForElement: anElement
	^ (anElement attributeAt: 'src')
		ifNotNil: [AtomTypedLink]
		ifNil:
			[(self classForType: (anElement attributeAt: 'type'))
				ifNil: [self defaultClassForElement: anElement]]! !

!AtomContent class methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2006 01:59'!
classForType: aString
	aString ifNotNil:
		[aString = 'html' ifTrue: [^ AtomTextHTML].
		aString = 'xhtml' ifTrue: [^ AtomTextXHTML].
		aString = 'text' ifTrue: [^ AtomText].
		(aString beginsWith: 'text/') ifTrue: [^ AtomTypedText].
		((aString endsWith: '+xml') or: [ aString endsWith: '/xml' ]) ifTrue: [ ^ AtomTypedXML ]].
	^ nil! !

!AtomContent class methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2006 01:55'!
defaultClassForElement: anElement
	^ anElement name = 'content'
		ifTrue: [AtomTypedBinary]
		ifFalse: [AtomText]! !

!AtomContent methodsFor: 'writing' stamp: 'avi 1/31/2006 01:50'!
contentOn: aStream
	self subclassResponsibility! !

!AtomContent methodsFor: 'accessing' stamp: 'avi 1/31/2006 01:47'!
type
	self subclassResponsibility! !

!AtomContent methodsFor: 'writing' stamp: 'avi 1/31/2006 02:06'!
typeOn: aStream elementName: aString
	self type ifNotNilDo:
		[:t |
		aStream	
			nextPutAll: ' type="';
			nextPutAll: t;
			nextPut: $"]! !

!AtomContent methodsFor: 'writing' stamp: 'avi 1/31/2006 02:05'!
xmlOn: aStream elementName: aString
	aStream
		nextPut: $<;
		nextPutAll: aString.
	self typeOn: aStream elementName: aString.
	aStream nextPut: $>.
		
	self contentOn: aStream.
	
	aStream
		nextPutAll: '</';
		nextPutAll: aString;
		nextPut: $>! !

AtomContent subclass: #AtomText
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atom-Content'!

!AtomText class methodsFor: 'as yet unclassified' stamp: 'avi 12/15/2005 21:52'!
text: aString
	^ self new text: aString! !

!AtomText methodsFor: 'writing' stamp: 'cwp 9/26/2007 23:36'!
contentOn: aStream
	aStream feedContent: text asString! !

!AtomText methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:52'!
text
	^ text! !

!AtomText methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:52'!
text: aString
	text _ aString! !

!AtomText methodsFor: 'accessing' stamp: 'avi 1/31/2006 01:51'!
type
	^ 'text'! !

!AtomText methodsFor: 'writing' stamp: 'avi 1/31/2006 02:07'!
typeOn: aStream elementName: aString
	aString = 'content' ifTrue: [super typeOn: aStream elementName: aString]! !

AtomContent subclass: #AtomTextHTML
	instanceVariableNames: 'html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atom-Content'!

!AtomTextHTML methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2006 01:58'!
contentOn: aStream
	html ifNotNil: [aStream nextPutAll: html]! !

!AtomTextHTML methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2006 01:58'!
text
	^ html! !

!AtomTextHTML methodsFor: 'as yet unclassified' stamp: 'cwp 7/27/2007 01:50'!
text: aString
	html := aString! !

!AtomTextHTML methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2006 01:51'!
type
	^ 'html'! !

AtomContent subclass: #AtomTextXHTML
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atom-Content'!

!AtomTextXHTML methodsFor: 'initializing' stamp: 'avi 1/31/2006 01:51'!
type
	^ 'xhtml'! !

AtomContent subclass: #AtomTypedContent
	instanceVariableNames: 'type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atom-Content'!

AtomTypedContent subclass: #AtomTypedBinary
	instanceVariableNames: 'data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atom-Content'!

!AtomTypedContent methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2006 01:28'!
type
	^ type! !

!AtomTypedContent methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2006 01:27'!
type: aString
	type _ aString! !

AtomTypedContent subclass: #AtomTypedLink
	instanceVariableNames: 'src'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atom-Content'!

AtomTypedContent subclass: #AtomTypedText
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atom-Content'!

AtomTypedContent subclass: #AtomTypedXML
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atom-Content'!

Object subclass: #AtomElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atom-Elements'!

AtomElement subclass: #AtomCoreElement
	instanceVariableNames: 'id title updated authors links'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atom-Elements'!

!AtomCoreElement methodsFor: 'convenience' stamp: 'avi 12/15/2005 21:09'!
addAuthor: aPerson
	^ self authors add: aPerson! !

!AtomCoreElement methodsFor: 'convenience' stamp: 'avi 12/15/2005 21:09'!
addLink: aLink
	^ self links add: aLink! !

!AtomCoreElement methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:10'!
authors
	^ authors ifNil: [authors _ OrderedCollection new]! !

!AtomCoreElement methodsFor: 'writing' stamp: 'bmp 12/23/2005 00:28'!
childrenOn: aStream
	self simpleElement: #id on: aStream.
	self simpleElement: #updated on: aStream.
	self childElement: #title on: aStream.
	self childList: #authors elementName: #author on: aStream.
	self childList: #links elementName: #link on: aStream! !

!AtomCoreElement methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:10'!
id
	^ id! !

!AtomCoreElement methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:10'!
id: uriString
	id _ uriString! !

!AtomCoreElement methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:10'!
links
	^ links ifNil: [links _ OrderedCollection new]! !

!AtomCoreElement methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:10'!
title
	^ title! !

!AtomCoreElement methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:10'!
title: aText
	title _ aText! !

!AtomCoreElement methodsFor: 'convenience' stamp: 'avi 12/16/2005 00:26'!
titleText
	^ self title ifNotNilDo: [:t | t text]! !

!AtomCoreElement methodsFor: 'convenience' stamp: 'avi 12/15/2005 21:10'!
titleText: aString
	self title: (AtomText text: aString)! !

!AtomCoreElement methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:10'!
updated
	^ updated! !

!AtomCoreElement methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:10'!
updated: aDateAndTime
	updated _ aDateAndTime! !

AtomCoreElement subclass: #AtomEntry
	instanceVariableNames: 'content summary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atom-Elements'!

!AtomEntry methodsFor: 'writing' stamp: 'avi 12/16/2005 01:31'!
childrenOn: aStream
	super childrenOn: aStream.
	self childElement: #content on: aStream.
	self childElement: #summary on: aStream! !

!AtomEntry methodsFor: 'accessing' stamp: 'avi 12/15/2005 20:58'!
content
	^ content! !

!AtomEntry methodsFor: 'accessing' stamp: 'avi 12/15/2005 20:58'!
content: aContent
	content _ aContent! !

!AtomEntry methodsFor: 'convenience' stamp: 'avi 1/31/2006 02:08'!
contentText
	^ self content ifNotNilDo: [:c | c text]! !

!AtomEntry methodsFor: 'convenience' stamp: 'avi 1/31/2006 02:08'!
contentText: aString
	self content: (AtomText text: aString)! !

!AtomEntry methodsFor: 'accessing' stamp: 'avi 12/15/2005 20:59'!
summary
	^ summary! !

!AtomEntry methodsFor: 'accessing' stamp: 'avi 12/15/2005 20:58'!
summary: aText
	summary _ aText! !

!AtomEntry methodsFor: 'convenience' stamp: 'avi 12/16/2005 00:26'!
summaryText
	^ self summary ifNotNilDo: [:s | s text]! !

!AtomEntry methodsFor: 'convenience' stamp: 'avi 12/15/2005 21:06'!
summaryText: aString
	self summary: (AtomText text: aString)! !

AtomCoreElement subclass: #AtomFeed
	instanceVariableNames: 'entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atom-Elements'!

!AtomFeed methodsFor: 'accessing' stamp: 'avi 12/16/2005 00:09'!
addEntry: anEntry
	^ self entries add: anEntry! !

!AtomFeed methodsFor: 'writing' stamp: 'bmp 12/23/2005 00:13'!
attributes
	^ { #xmlns -> 'http://www.w3.org/2005/Atom' }.! !

!AtomFeed methodsFor: 'writing' stamp: 'bmp 12/23/2005 00:28'!
childrenOn: aStream
	super childrenOn: aStream.
	self childList: #entries elementName: #entry on: aStream! !

!AtomFeed methodsFor: 'writing' stamp: 'avi 12/16/2005 01:24'!
elementName
	^ 'feed'! !

!AtomFeed methodsFor: 'accessing' stamp: 'avi 12/16/2005 00:09'!
entries
	^ entries ifNil: [entries _ OrderedCollection new]! !

!AtomFeed methodsFor: 'writing' stamp: 'bmp 12/23/2005 00:11'!
hasAttributes
	^ true! !

!AtomElement methodsFor: 'writing' stamp: 'avi 12/16/2005 01:46'!
attributeSelectors
	self subclassResponsibility! !

!AtomElement methodsFor: 'writing' stamp: 'avi 12/16/2005 01:45'!
attributes
	^ self attributeSelectors collect: [:ea | ea -> (self perform: ea)]! !

!AtomElement methodsFor: 'writing' stamp: 'avi 12/16/2005 01:43'!
attributesOn: aStream
	self attributes do:
		[:assoc |
		assoc value ifNotNil:
			[aStream space.
			aStream nextPutAll: assoc key.
			aStream nextPutAll: '="'.
			aStream nextPutAll: assoc value.
			aStream nextPut: $"]]! !

!AtomElement methodsFor: 'writing' stamp: 'avi 12/16/2005 01:33'!
childElement: aSymbol on: aStream
	(self perform: aSymbol) ifNotNilDo:
		[:s |
		s xmlOn: aStream elementName: aSymbol]! !

!AtomElement methodsFor: 'writing' stamp: 'bmp 12/23/2005 00:27'!
childList: aSymbol elementName: elementName on: aStream
	(self perform: aSymbol) do:
		[:ea |
		ea xmlOn: aStream elementName: elementName]! !

!AtomElement methodsFor: 'writing' stamp: 'avi 12/16/2005 01:23'!
childrenOn: aStream! !

!AtomElement methodsFor: 'writing' stamp: 'avi 12/16/2005 01:20'!
elementName
	self subclassResponsibility! !

!AtomElement methodsFor: 'writing' stamp: 'avi 12/16/2005 01:44'!
hasAttributes
	^ false! !

!AtomElement methodsFor: 'writing' stamp: 'avi 12/16/2005 01:22'!
hasChildren
	^ true! !

!AtomElement methodsFor: 'writing' stamp: 'avi 12/16/2005 01:33'!
simpleElement: aSymbol on: aStream
	(self perform: aSymbol) ifNotNilDo:
		[:s |
		aStream nextPut: $<; nextPutAll: aSymbol; nextPut: $>.
		aStream nextPutAll: s asString.
		aStream nextPutAll: '</'; nextPutAll: aSymbol; nextPut: $>]! !

!AtomElement methodsFor: 'writing' stamp: 'avi 12/16/2005 01:08'!
xmlDocumentOn: aStream
	aStream nextPutAll: '<?xml version="1.0" encoding="utf-8"?>'.
	self xmlOn: aStream
! !

!AtomElement methodsFor: 'writing' stamp: 'avi 12/16/2005 01:00'!
xmlDocumentString
	^ String streamContents: [:s | self xmlDocumentOn: s]! !

!AtomElement methodsFor: 'writing' stamp: 'avi 12/16/2005 01:20'!
xmlOn: aStream
	self xmlOn: aStream elementName: self elementName! !

!AtomElement methodsFor: 'writing' stamp: 'avi 12/16/2005 01:45'!
xmlOn: aStream elementName: aString
	aStream nextPut: $<.
	aStream nextPutAll: aString.
	self hasAttributes ifTrue: [self attributesOn: aStream].
	self hasChildren
		ifFalse: [aStream nextPutAll: '/>']
		ifTrue:
			[aStream nextPut: $>.
			self childrenOn: aStream.
			aStream nextPutAll: '</'.
			aStream nextPutAll: aString.
			aStream nextPut: $>]! !

AtomElement subclass: #AtomLink
	instanceVariableNames: 'href rel type title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atom-Elements'!

!AtomLink methodsFor: 'writing' stamp: 'avi 12/16/2005 01:44'!
attributeSelectors
	^ #(href rel type title)! !

!AtomLink methodsFor: 'convenience' stamp: 'cwp 9/26/2007 21:27'!
beAlternate
	self rel: 'alternate'! !

!AtomLink methodsFor: 'convenience' stamp: 'cwp 9/26/2007 21:28'!
beEnclosure
	self rel: 'enclosure'! !

!AtomLink methodsFor: 'convenience' stamp: 'cwp 9/26/2007 21:28'!
beRelated
	self rel: 'related'! !

!AtomLink methodsFor: 'convenience' stamp: 'cwp 9/26/2007 21:28'!
beSelf
	self rel: 'self'! !

!AtomLink methodsFor: 'convenience' stamp: 'cwp 9/26/2007 21:28'!
beVia
	self rel: 'via'! !

!AtomLink methodsFor: 'writing' stamp: 'avi 12/16/2005 01:46'!
hasAttributes
	^ true! !

!AtomLink methodsFor: 'writing' stamp: 'avi 12/16/2005 01:43'!
hasChildren
	^ false! !

!AtomLink methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:29'!
href
	^ href! !

!AtomLink methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:29'!
href: uriString
	href _ uriString! !

!AtomLink methodsFor: 'convenience' stamp: 'cwp 9/26/2007 21:28'!
isAlternate
	^ self rel = 'alternate' or: [self rel isNil]! !

!AtomLink methodsFor: 'convenience' stamp: 'cwp 9/26/2007 21:28'!
isEnclosure
	^ self rel = 'enclosure'! !

!AtomLink methodsFor: 'convenience' stamp: 'cwp 9/26/2007 21:28'!
isRelated
	^ self rel = 'related'! !

!AtomLink methodsFor: 'convenience' stamp: 'cwp 9/26/2007 21:28'!
isSelf
	^ self rel = 'self'! !

!AtomLink methodsFor: 'convenience' stamp: 'cwp 9/26/2007 21:28'!
isVia
	^ self rel = 'via'! !

!AtomLink methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:30'!
rel
	^ rel! !

!AtomLink methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:30'!
rel: aString
	rel _ aString! !

!AtomLink methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:32'!
title
	^ title! !

!AtomLink methodsFor: 'accessing' stamp: 'avi 12/15/2005 23:54'!
title: aString
	title _ aString! !

!AtomLink methodsFor: 'accessing' stamp: 'avi 12/16/2005 01:45'!
type
	^ type! !

!AtomLink methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:30'!
type: aString
	type _ aString! !

AtomElement subclass: #AtomPerson
	instanceVariableNames: 'name uri email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atom-Elements'!

!AtomPerson methodsFor: 'writing' stamp: 'avi 12/16/2005 01:46'!
childrenOn: aStream
	self simpleElement: #name on: aStream.
	self simpleElement: #uri on: aStream.
	self simpleElement: #email on: aStream! !

!AtomPerson methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:51'!
email
	^ email! !

!AtomPerson methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:51'!
email: aString
	email _ aString! !

!AtomPerson methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:51'!
name
	^ name! !

!AtomPerson methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:50'!
name: aString
	name _ aString! !

!AtomPerson methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:51'!
uri
	^ uri! !

!AtomPerson methodsFor: 'accessing' stamp: 'avi 12/15/2005 21:51'!
uri: aString
	uri _ aString! !
